public class SortierteListe<T extends Comparable<T>> {

    private class Item {
        T value;
	Item next;
    }

    private Item first;
    private Item last;

    public void insert(T elem) {
        Item pred = null;
        Item succ = first;
	Item item;

	while (succ!=null && elem.compareTo(succ.value) >= 0) {
	    pred = succ;
	    succ = succ.next;
	}

	item = new Item();		/* Hilfsobjekt anlegen */
	item.next = succ;		/* Nachfolger setzen */
	item.value = elem;		/* Wert speichern */

	if (pred == null) {		/* neues kleinstes Element? */
	    first = item;		/* ja, ist jetzt first      */
	}
	else {
	    pred.next = item;		/* nein, dann Nachfolger von Vorgaenger neu setzen */
	}

	if (succ==null) {		/* neues groesstes Element? */
	    last = item;		/* Dann haben wir ein neues last */
	}
    }

    public void deleteMin() {
        if (first == null) {
	    throw new IllegalStateException("Liste ist leer");
	}

	first = first.next;
	if (first == null) {		/* Liste jetzt leer? */
	    last = null;
	}
    }

    public T getMin() {
        return first==null? null : first.value;		/* liefert null bei leerer Liste */
    }

    public void print() {
        Item item = first;

	while (item != null) {
	    System.out.println(item.value);
	    item = item.next;
	}
    }
}
